package cn.com.ctop.toutiao.modules.material.controller;


import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import cn.com.ctop.toutiao.modules.material.entity.ByteDanceCreativeWordPackage;
import cn.com.ctop.toutiao.modules.material.service.IByteDanceCreativeWordPackageService;
import org.jeecg.common.api.vo.Result;
import cn.com.ctop.common.module.utils.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * 创意动态词包信息
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2021-05-19
 */
@Slf4j
@Api(tags = "创意动态词包信息")
@RestController
@RequestMapping("/ctop/ByteDanceCreativeWordPackage")
public class ByteDanceCreativeWordPackageController {
    @Autowired
    private IByteDanceCreativeWordPackageService ByteDanceCreativeWordPackageService;

    /**
     * 分页列表查询
     *
     * @param ByteDanceCreativeWordPackage
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @ApiOperation(value = "创意动态词包信息-分页列表查询", notes = "创意动态词包信息-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<ByteDanceCreativeWordPackage>> queryPageList(ByteDanceCreativeWordPackage ByteDanceCreativeWordPackage,
                                                                     @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                                     @RequestParam(name = "pageSize", defaultValue = "100") Integer pageSize,
                                                                     HttpServletRequest req) {
        Result<IPage<ByteDanceCreativeWordPackage>> result = new Result<>();
        QueryWrapper<ByteDanceCreativeWordPackage> queryWrapper = QueryGenerator.initQueryWrapper(ByteDanceCreativeWordPackage, req.getParameterMap());
        Page<ByteDanceCreativeWordPackage> page = new Page<ByteDanceCreativeWordPackage>(pageNo, pageSize);
        IPage<ByteDanceCreativeWordPackage> pageList = ByteDanceCreativeWordPackageService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * 添加
     *
     * @param ByteDanceCreativeWordPackage
     * @return
     */
    @ApiOperation(value = "创意动态词包信息-添加", notes = "创意动态词包信息-添加")
    @PostMapping(value = "/add")
    public Result<ByteDanceCreativeWordPackage> add(@RequestBody ByteDanceCreativeWordPackage ByteDanceCreativeWordPackage) {
        Result<ByteDanceCreativeWordPackage> result = new Result<>();
        try {
            ByteDanceCreativeWordPackageService.save(ByteDanceCreativeWordPackage);
            result.success("添加成功！");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     *
     * @param ByteDanceCreativeWordPackage
     * @return
     */
    @ApiOperation(value = "创意动态词包信息-编辑", notes = "创意动态词包信息-编辑")
    @PutMapping(value = "/edit")
    public Result<ByteDanceCreativeWordPackage> edit(@RequestBody ByteDanceCreativeWordPackage ByteDanceCreativeWordPackage) {
        Result<ByteDanceCreativeWordPackage> result = new Result<ByteDanceCreativeWordPackage>();
        ByteDanceCreativeWordPackage ByteDanceCreativeWordPackageEntity = ByteDanceCreativeWordPackageService.getById(ByteDanceCreativeWordPackage.getId());
        if (ByteDanceCreativeWordPackageEntity == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = ByteDanceCreativeWordPackageService.updateById(ByteDanceCreativeWordPackage);
            if (ok) {
                result.success("修改成功!");
            }
        }

        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @ApiOperation(value = "创意动态词包信息-通过id删除", notes = "创意动态词包信息-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<?> delete(@RequestParam(name = "id") String id) {
        try {
            ByteDanceCreativeWordPackageService.removeById(id);
        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @ApiOperation(value = "创意动态词包信息-批量删除", notes = "创意动态词包信息-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<ByteDanceCreativeWordPackage> deleteBatch(@RequestParam(name = "ids") String ids) {
        Result<ByteDanceCreativeWordPackage> result = new Result<>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.ByteDanceCreativeWordPackageService.removeByIds(Arrays.asList(ids.split(",")));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @ApiOperation(value = "创意动态词包信息-通过id查询", notes = "创意动态词包信息-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<ByteDanceCreativeWordPackage> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<ByteDanceCreativeWordPackage> result = new Result<>();
        ByteDanceCreativeWordPackage ByteDanceCreativeWordPackage = ByteDanceCreativeWordPackageService.getById(id);
        if (ByteDanceCreativeWordPackage == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(ByteDanceCreativeWordPackage);
            result.setSuccess(true);
        }
        return result;
    }

    /**
     * 导出excel
     *
     * @param request
     * @param response
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
        // Step.1 组装查询条件
        QueryWrapper<ByteDanceCreativeWordPackage> queryWrapper = null;
        try {
            String paramsStr = request.getParameter("paramsStr");
            if (oConvertUtils.isNotEmpty(paramsStr)) {
                String deString = URLDecoder.decode(paramsStr, "UTF-8");
                ByteDanceCreativeWordPackage ByteDanceCreativeWordPackage = JSON.parseObject(deString, ByteDanceCreativeWordPackage.class);
                queryWrapper = QueryGenerator.initQueryWrapper(ByteDanceCreativeWordPackage, request.getParameterMap());
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<ByteDanceCreativeWordPackage> pageList = ByteDanceCreativeWordPackageService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME, "创意动态词包信息列表");
        mv.addObject(NormalExcelConstants.CLASS, ByteDanceCreativeWordPackage.class);
        mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("创意动态词包信息列表数据", "导出人:Jeecg", "导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
        return mv;
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
        for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
            MultipartFile file = entity.getValue();
            ImportParams params = new ImportParams();
            params.setTitleRows(2);
            params.setHeadRows(1);
            params.setNeedSave(true);
            try {
                List<ByteDanceCreativeWordPackage> listByteDanceCreativeWordPackages = ExcelImportUtil.importExcel(file.getInputStream(), ByteDanceCreativeWordPackage.class, params);
                ByteDanceCreativeWordPackageService.saveBatch(listByteDanceCreativeWordPackages);
                return Result.ok("文件导入成功！数据行数:" + listByteDanceCreativeWordPackages.size());
            } catch (Exception e) {
                log.error(e.getMessage(), e);
                return Result.error("文件导入失败:" + e.getMessage());
            } finally {
                try {
                    file.getInputStream().close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return Result.ok("文件导入失败！");
    }

}

